//***** Bluetooth Speaker Wifi Clock Arduino  Crazy Indiana*****//
/*************************************************************
*  CRAZY INDIANA Bluetooth Speaker Wifi Clock                 *
*  Website www.crazyindiana.in                                *
*  Youtube www.youtube.com/c/CrazyIndiana                     *
**************************************************************/

//For Arduino NaNo - Gets Time/Temp Sync From ESP-01//

#include <MD_Parola.h>
#include <MD_MAX72xx.h>
#include <SPI.h>
#include <TimeLib.h>
#include <SoftwareSerial.h>

char daysOfTheWeek[7][10] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};
char spellMonth[12][6] = {"Jan","Feb","March","April","May","June","July","Aug","Sep","Oct","Nov","Dec"};


char strTime[12]={ "" };      //Store time
char strBDate[50]={ "" };     //Store date
char strTemp[10]={ "" };      //Store Temperature
char strHum[10]={ "" };       //Store Humidity
char strBMsg[]={ "" };        //Store Blynk Message

bool DFlag = false;       // Data Received Flag
int intZ=1;               // Case Loop Flag
bool CTFlag=false ;       // Call getTime()
int intDTime=0;           // Display Time 
bool BMFlag=false ;       // Check Blynk message flag
int intBtn=0;             // Check Button Press 
//const int Buzzpin = 15;   // Buzzer Pin
//const int Btnpin = 16;    // Button Key press Pin
SoftwareSerial Nano(2,3); //Rx, Tx


#define HARDWARE_TYPE MD_MAX72XX::FC16_HW
#define MAX_DEVICES 4
#define CLK_PIN   13  // or SCK
#define DATA_PIN  11  // or MOSI
#define CS_PIN    10  // or SS

// Hardware SPI connection
MD_Parola P = MD_Parola(HARDWARE_TYPE, CS_PIN, MAX_DEVICES);



void setup() 
{     
      Nano.begin(9600);
      intZ=1;
      Serial.begin(57600);
      setTime(1,25, 05, 9, 11, 2021);
      P.begin();
      P.setIntensity(2); 
      P.displayText("BT Wifi Speaker Clock - Crazy Indiana", PA_LEFT, 35,10000, PA_SCROLL_LEFT, PA_SCROLL_LEFT);
      getData();
      delay(10000);
      getData();
      delay(10000);
      getData();
      delay(10000);
      getData();
     
}

//-------------Function for Reading Incoming Data from ESP01---------------------//
void getData()
{ 
    String strDataTime;
    String strDataTemp;
    String temp;
    
    if (Nano.available()) 
    {   Serial.println("Nano Serial ok");
        //Serial.println(Nano.read()); 
        Serial.println(Nano.readString()); 
        strDataTime=Nano.readString();
        strDataTemp=Nano.readString();
        Serial.println(strDataTime);
    }
    Serial.print("Reading Data1: ");
    Serial.println(strDataTime);
    Serial.print("Reading Data2: ");
    Serial.println(strDataTemp);
    
    //strDataTime="060730122001";
    //strDataTemp="0509";

    temp = strDataTime.substring(0,2);
    int inthour = temp.toInt();
    temp = strDataTime.substring(2,4); 
    int intmin = temp.toInt();
    temp = strDataTime.substring(4,6); 
    int intday = temp.toInt();
    temp = strDataTime.substring(6,8); 
    int intmth = temp.toInt();
    temp = strDataTime.substring(8,12); 
    int intyear = temp.toInt();
    //setTime(1,25, 05, 9, 11, 2021);
    setTime(inthour,intmin,30,intday,intmth,intyear);
    
    
    
      temp = strDataTemp.substring(12,16);
      strDataTemp= temp;
     
            
      temp = strDataTemp.substring(0,2);
      int intT = temp.toInt();
      temp = strDataTemp.substring(2,4);    
      int intH = temp.toInt();
      
      sprintf(strTemp,"T: %d\xB0",intT);
      sprintf(strTemp,"%sc",strTemp);
      sprintf(strHum,"H: %d",intH);
      strcat(strHum,"%");
  
  delay(1000); 
}
//--------------------------------


//-------------Function for Reading Clock Time---------------------//
void getTime( bool f = true)

{ 
  //Serial.println("Gettime");
  intDTime++;
    time_t t = now();
    char strhour[3]={ "" };
    char strmin[3]={ "" };
    int inthour = hour(t)%12; ////%12;
    int intmin = minute(t);
   
    if (inthour <10) 
    { sprintf(strhour,"0%d",inthour);}
    else 
    { sprintf(strhour,"%d",inthour); }
    
    if (inthour == 0)
    { inthour =12 ; sprintf(strhour,"%d%",inthour);}

        
    if (intmin <10) 
    { sprintf(strmin,"0%d",intmin); }
    else 
    { sprintf(strmin,"%d",intmin); }
    
    sprintf(strTime,"%s%c%s", strhour,(f ? ':' : ' '), strmin);
   
  
    if (intDTime==15) // How long time to Display in sec.
    { CTFlag=false;
      intDTime=0;
      intZ++;
      //P.displayReset();
    }
  
}
//-------------------------------------------------//

void loop() 
{   
    static uint32_t lastTime = 0; // millis() memory
    static bool flasher = false;

    if(P.displayAnimate())
    
     { 
           if (BMFlag == true)
           { 
              P.displayText(strBMsg, PA_LEFT, 35,2000, PA_SCROLL_LEFT, PA_SCROLL_LEFT);
              BMFlag = false;
              //Beep();
           }
           else
           {
           switch (intZ)
               {
                  case 1:
                  //Serial.println("CaseNo1 : " + intZ);
                  P.displayText(strTime, PA_CENTER, 0,1000, PA_PRINT, PA_NO_EFFECT);
                  //intZ++;
                  CTFlag=true;
                  P.displayReset();
                  break;
                  
                  case 2:
                  P.displayText(strTemp, PA_CENTER,100,10000, PA_SCROLL_UP, PA_SCROLL_UP);
                  intZ++;
                  break;
                  
                  case 3:
                  P.displayText(strHum, PA_CENTER,100,10000, PA_SCROLL_UP, PA_SCROLL_UP);
                  intZ++;
                  P.displayReset();
                  break;
                  
                  case 4:
                  //Display date like --- Monday 5 Jan 2020//
                  time_t t = now();
                  int intwd=weekday(t)-1;
                  sprintf(strBDate,"%s %d %s %d",daysOfTheWeek[intwd],day(t),spellMonth[month(t)-1],year(t));                 
                  P.displayText(strBDate, PA_LEFT, 35,2000, PA_SCROLL_LEFT, PA_SCROLL_LEFT);
                  intZ=1;
                  P.displayReset();
                  break;
    
               }
           }
         
           P.displayClear();
           P.displayReset();
     }

    // Finally, adjust the time string if we have to
      if (millis() - lastTime >= 1000)
      {  
        lastTime = millis();
        //getsec(szsecond);
  
        if (CTFlag == true)
        {
        getTime(flasher);
        flasher = !flasher;
        P.displayReset();
        }
      }

}
